//
// Copyright (c) 2005, Michael Schwarz. (http://www.schwarz-interactive.de/)
// All rights reserved.
//   
// Redistribution and use in source and binary forms, with or without modification, 
// are permitted provided that the following conditions are met: 
//   
// (1) Redistributions of source code must retain the above copyright 
//     notice, this list of conditions and the following disclaimer.
// (2) Redistributions in binary form must reproduce the above copyright 
//     notice, this list of conditions and the following disclaimer in the
//     documentation and/or other materials provided with the distribution. 
// (3) Neither the name schwarz-interactive nor the names of its contributors
//     may be used to endorse or promote products derived from this software 
//     without specific prior written permission.
//       
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
// BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
// OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
// 
// For some portions of this software, additional copyright notices apply, 
// which can be found in the source code files.
//
// Author: Michael Schwarz, info@schwarz-interactive.de
//
//
using System;

namespace CSharpSample
{
	internal sealed class GuidConverter : Ajax.JSON.IAjaxObjectConverter
	{
		public void RenderClientScript(ref System.Text.StringBuilder sb)
		{
		}

		public string ClientScriptIdentifier{ get{ return null; } }

		public object FromString(string s, Type t)
		{
			throw new NotImplementedException();
		}

		public void ToJSON(ref System.Text.StringBuilder sb, object o)
		{
			Ajax.JSON.DefaultConverter.ToJSON(ref sb, ((System.Guid)o).ToString());
		}

		public Type[] SupportedTypes
		{
			get
			{
				return new Type[]{typeof(System.Guid)};
			}
		}

		public bool IncludeSubclasses
		{
			get{ return false; }
		}
	}
}
