Imports System

Public Class DateTimeConverter
    Implements Ajax.JSON.IAjaxObjectConverter

    Public Function FromString(ByVal s As String, ByVal t As System.Type) As Object Implements Ajax.JSON.IAjaxObjectConverter.FromString

        If s Is Nothing Or s = "" Then
            Return DateTime.Now
        End If

        If s.Length = 8 Then

            Return New DateTime(Convert.ToInt32(s.Substring(0, 4)), Convert.ToInt32(s.Substring(4, 2)), Convert.ToInt32(s.Substring(6, 2)))

        ElseIf s.Length = 14 Then

            Return New DateTime(Convert.ToInt32(s.Substring(0, 4)), Convert.ToInt32(s.Substring(4, 2)), Convert.ToInt32(s.Substring(6, 2)), Convert.ToInt32(s.Substring(8, 2)), Convert.ToInt32(s.Substring(10, 2)), Convert.ToInt32(s.Substring(12, 2)))

        End If

        Throw New NotImplementedException

    End Function

    Public Sub RenderClientScript(ByRef sb As System.Text.StringBuilder) Implements Ajax.JSON.IAjaxObjectConverter.RenderClientScript

        sb.Append("function digi(v, c){v = v + '';var n = '0000';if(v.length < c) return n.substr(0, c-v.length) + v;return v;}" & Chr(13) & Chr(10))
        sb.Append("function DateTime(year,month,day,hours,minutes,seconds){	if(year>9999||year<1970||month<1||month>12||day<0||day>31||hours<0||hours>23||minutes<0||minutes>59||seconds<0||seconds>59)throw('ArgumentException');this.Year = year;this.Month = month;this.Day = day;this.Hours = hours;this.Minutes = minutes;this.Seconds = seconds;}" & Chr(13) & Chr(10))
        sb.Append("DateTime.prototype.toString = function(){return digi(this.Year,4) + digi(this.Month,2) + digi(this.Day,2) + digi(this.Hours,2) + digi(this.Minutes,2) + digi(this.Seconds,2);}" & Chr(13) & Chr(10))

    End Sub

    Public ReadOnly Property SupportedTypes() As System.Type() Implements Ajax.JSON.IAjaxObjectConverter.SupportedTypes
        Get
            Return New Type() {GetType(System.DateTime)}
        End Get
    End Property

    Public ReadOnly Property ClientScriptIdentifier() As String Implements Ajax.JSON.IAjaxObjectConverter.ClientScriptIdentifier
        Get
            Return "AjaxDateTime"
        End Get
    End Property

    Public ReadOnly Property IncludeSubclasses() As Boolean Implements Ajax.JSON.IAjaxObjectConverter.IncludeSubclasses
        Get
            Return True
        End Get
    End Property

    Public Sub ToJSON(ByRef sb As System.Text.StringBuilder, ByVal o As Object) Implements Ajax.JSON.IAjaxObjectConverter.ToJSON

        Dim d As DateTime

        If o.GetType() Is GetType(System.DateTime) Or o.GetType().BaseType Is GetType(System.DateTime) Then

            d = CDate(o)
            sb.Append("new Date(" + d.Year + "," + (d.Month - 1) + "," + d.Day + "," + d.Hour + "," + d.Minute + "," + d.Second + ")")

        End If

    End Sub
End Class


